> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.shipbob.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.shipbob.com/_mcp/server.

# Retrieves List of Products based on filters provided


GET https://api.shipbob.com/Experimental/product

Reference: https://developer.shipbob.com/experimental/api/products/retrieves-list-of-products-based-on-filters-provided

## Authentication

- `Authorization` header (bearer token, required) — Authentication using Personal Access Token (PAT) token
- `Authorization` header (bearer token, required) — OAuth2 authentication using JWT tokens

## Servers

- `https://api.shipbob.com` (https://api.shipbob.com, default)
- `https://sandbox-api.shipbob.com` (https://sandbox-api.shipbob.com)

## Request

### Query parameters

- `Search` (string, optional) — Search Products by name, sku, inventory id or product Id.
- `Barcode` (string, optional) — Barcode Associated with variant
- `ChannelIds` (list of integer, optional) — Looks for Products variants by their channel IDs
- `HasDigitalVariants` (boolean, optional) — Looks for Products with/without digital variants
- `HasVariants` (boolean, optional) — Looks for Products with/without variants
- `InventoryId` (list of integer, optional) — Looks for variants by its associated inventory id
- `LastUpdatedTimestamp` (string, optional) — Looks for Products that have been updated since the given date
- `LegacyIds` (list of integer, optional) — Looks for Products with by Legacy Product Id(s)
- `Name` (string, optional) — Looks for Products/Variants by name
- `OnHand` (integer, optional) — Looks for Products with inventory
- `PlatformIds` (list of string, optional) — Looks for Products variants by their external Platform IDs
- `ProductId` (list of integer, optional) — Looks for Products with an assigned Id
- `ProductType` (integer, optional) — Looks for Products by type
- `ReviewsPending` (list of enum, optional) — Looks for Products by ReviewsPending
  - Allowed values: `0`, `1`, `2`, `3`, `4`
- `SalesChannel` (list of string, optional) — Looks for Products variants assigned to a platform/sales channel
- `SellerSKU` (string, optional) — Looks for Products that match the provided Seller query
- `SKU` (string, optional) — Looks for Products that match the provided Sku query
- `TaxonomyIds` (list of integer, optional) — Looks for Products variants by their taxonomy id or any descendants of the taxonomies sent separated by comma
- `VariantId` (list of integer, optional) — Looks for products that contain a variant with the given ID
- `VariantStatus` (string, optional) — Looks for Products with variants that contain provided status
- `PageSize` (integer, optional) — 1-250
- `SortBy` (string, optional) — Id, Name, Category, TotalOnHandQty
- `SortOrder` (string, optional) — ASC,DESC

## Response

### 200

Success

- `first` (string, optional, nullable)
- `items` (list of object, optional, nullable)
  - `created_on` (datetime, optional)
  - `id` (long, optional)
  - `name` (string, optional, nullable)
  - `taxonomy` (object, optional)
    - `id` (integer, optional, nullable)
    - `name` (string, optional, nullable)
    - `parent_id` (integer, optional, nullable)
    - `parent_name` (string, optional, nullable)
    - `path` (string, optional, nullable)
  - `type` (string, optional, nullable)
  - `updated_on` (datetime, optional, nullable)
  - `user_id` (long, optional)
  - `variants` (list of object, optional, nullable)
    - `additional_hazmat_attributes` (object, optional)
      - `charge_state_percentage` (double, optional, nullable)
      - `container_metal` (boolean, optional, nullable)
      - `lithium_battery_packaging` (string, optional, nullable)
      - `lithium_battery_type` (string, optional, nullable)
      - `magnet` (boolean, optional, nullable)
      - `net_volume` (double, optional, nullable)
      - `net_weight` (double, optional, nullable)
    - `associated_bundles` (list of object, optional, nullable)
      - `product_id` (long, optional)
      - `product_name` (string, optional, nullable)
      - `quantity` (integer, optional)
      - `variant_id` (long, optional)
      - `variant_sku` (string, optional, nullable)
    - `barcodes` (list of object, optional, nullable)
      - `sticker_url` (string, optional, nullable)
      - `value` (string, optional, nullable)
    - `bundle_definition` (list of object, optional, nullable)
      - `product_id` (long, optional)
      - `quantity` (integer, optional)
      - `variant_id` (long, optional)
      - `variant_name` (string, optional, nullable)
      - `variant_sku` (string, optional, nullable)
    - `channel_metadata` (list of object or object or object or object, optional, nullable)
      - Products.ChannelMetadataViewModel
        - `channel_id` (long, optional)
        - `channel_name` (string, optional, nullable)
        - `currency` (string, optional, nullable)
        - `id` (long, optional)
        - `is_inventory_sync_enabled` (boolean, optional)
        - `legacy_product_id` (long, optional, nullable)
        - `platform` (string, optional, nullable)
        - `platform_identifier` (string, optional, nullable)
        - `platform_inventory_item_id` (string, optional, nullable)
        - `price` (double, optional)
        - `seller_sku` (string, optional, nullable)
      - Products.AmazonChannelMetadataViewModel
        - `asin` (string, optional, nullable)
        - `channel_id` (long, optional)
        - `channel_name` (string, optional, nullable)
        - `currency` (string, optional, nullable)
        - `fnsku` (string, optional, nullable)
        - `fulfillment_channel` (string, optional, nullable)
        - `id` (long, optional)
        - `is_inventory_sync_enabled` (boolean, optional)
        - `legacy_product_id` (long, optional, nullable)
        - `platform` (string, optional, nullable)
        - `platform_identifier` (string, optional, nullable)
        - `platform_inventory_item_id` (string, optional, nullable)
        - `price` (double, optional)
        - `seller_sku` (string, optional, nullable)
      - Products.BigCommerceChannelMetadataViewModel
        - `channel_id` (long, optional)
        - `channel_name` (string, optional, nullable)
        - `currency` (string, optional, nullable)
        - `id` (long, optional)
        - `is_inventory_sync_enabled` (boolean, optional)
        - `legacy_product_id` (long, optional, nullable)
        - `platform` (string, optional, nullable)
        - `platform_identifier` (string, optional, nullable)
        - `platform_inventory_item_id` (string, optional, nullable)
        - `platform_product_id` (long, optional, nullable)
        - `platform_variant_id` (long, optional, nullable)
        - `price` (double, optional)
        - `seller_sku` (string, optional, nullable)
      - Products.ShopifyChannelMetadataViewModel
        - `channel_id` (long, optional)
        - `channel_name` (string, optional, nullable)
        - `currency` (string, optional, nullable)
        - `id` (long, optional)
        - `is_inventory_sync_enabled` (boolean, optional)
        - `legacy_product_id` (long, optional, nullable)
        - `platform` (string, optional, nullable)
        - `platform_identifier` (string, optional, nullable)
        - `platform_inventory_item_id` (string, optional, nullable)
        - `price` (double, optional)
        - `seller_sku` (string, optional, nullable)
    - `created_on` (datetime, optional)
    - `customs` (object, optional)
      - `country_code_of_origin` (string, optional, nullable)
      - `currency` (string, optional, nullable)
      - `description` (string, optional, nullable)
      - `hs_tariff_code` (string, optional, nullable)
      - `is321_eligible` (boolean, optional)
      - `value` (integer, optional, nullable)
    - `dimension` (object, optional)
      - `height` (double, optional)
      - `is_locked` (boolean, optional)
      - `length` (double, optional)
      - `source` (string, optional, nullable)
      - `unit` (string, optional, nullable)
      - `width` (double, optional)
    - `fulfillment_settings` (object, optional)
      - `dangerous_goods` (boolean, optional)
      - `is_bpm_parcel` (boolean, optional)
      - `is_case_pick` (boolean, optional)
      - `msds_url` (string, optional, nullable)
      - `requires_prop65` (boolean, optional)
      - `serial_scan` (object, optional)
        - `exact_character_length` (integer, optional, nullable)
        - `is_enabled` (boolean, optional)
        - `prefix` (string, optional, nullable)
        - `suffix` (string, optional, nullable)
    - `gtin` (string, optional, nullable)
    - `id` (long, optional)
    - `inventory` (object, optional)
      - `inventory_id` (integer, optional, nullable)
      - `on_hand_qty` (integer, optional)
    - `is_digital` (boolean, optional)
    - `is_image_uploaded` (boolean, optional)
    - `lot_information` (object, optional)
      - `is_lot` (boolean, optional)
      - `minimum_shelf_life_days` (integer, optional, nullable)
    - `merge_children` (list of object, optional, nullable)
      - `channel_ids` (list of long, optional, nullable)
      - `completed_at` (datetime, optional)
      - `inventory_id` (long, optional, nullable)
      - `variant_id` (long, optional)
      - `variant_name` (string, optional, nullable)
    - `name` (string, optional, nullable)
    - `packaging_material_type` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional, nullable)
    - `packaging_requirement` (object, optional)
      - `id` (long, optional)
      - `name` (string, optional, nullable)
    - `return_preferences` (object, optional)
      - `backup_action` (object, optional)
        - `id` (long, optional)
        - `name` (string, optional, nullable)
      - `instructions` (string, optional, nullable)
      - `primary_action` (object, optional)
        - `id` (long, optional)
        - `name` (string, optional, nullable)
      - `return_to_sender_backup_action` (object, optional)
        - `id` (long, optional)
        - `name` (string, optional, nullable)
      - `return_to_sender_primary_action` (object, optional)
        - `id` (long, optional)
        - `name` (string, optional, nullable)
    - `reviews_pending` (list of string, optional, nullable)
    - `sku` (string, optional, nullable)
    - `status` (string, optional, nullable)
    - `upc` (string, optional, nullable)
    - `updated_on` (datetime, optional, nullable)
    - `weight` (object, optional)
      - `unit` (string, optional, nullable)
      - `weight` (double, optional)
- `last` (string, optional, nullable)
- `next` (string, optional, nullable)
- `prev` (string, optional, nullable)

## Errors

### 400 Bad Request Error

Bad Request

- `map from string to list of string`

### 404 Not Found Error

Not Found

- `object or object`
  - Products.ProblemDetails
    - `detail` (string, optional, nullable)
    - `instance` (string, optional, nullable)
    - `status` (integer, optional, nullable)
    - `title` (string, optional, nullable)
    - `type` (string, optional, nullable)
  - Products.HttpValidationProblemDetails
    - `detail` (string, optional, nullable)
    - `errors` (map from string to list of string, optional, nullable)
    - `instance` (string, optional, nullable)
    - `status` (integer, optional, nullable)
    - `title` (string, optional, nullable)
    - `type` (string, optional, nullable)

## Examples

**Response**

```json
{
  "first": "string",
  "items": [
    {
      "created_on": "2019-08-24T14:15:22+00:00",
      "id": 0,
      "name": "string",
      "taxonomy": {
        "id": 0,
        "name": "string",
        "parent_id": 0,
        "parent_name": "string",
        "path": "string"
      },
      "type": "string",
      "updated_on": "2019-08-24T14:15:22+00:00",
      "user_id": 0,
      "variants": [
        {
          "additional_hazmat_attributes": {
            "charge_state_percentage": 0.1,
            "container_metal": true,
            "lithium_battery_packaging": "string",
            "lithium_battery_type": "string",
            "magnet": true,
            "net_volume": 0.1,
            "net_weight": 0.1
          },
          "associated_bundles": [
            {
              "product_id": 0,
              "product_name": "string",
              "quantity": 0,
              "variant_id": 0,
              "variant_sku": "string"
            }
          ],
          "barcodes": [
            {
              "sticker_url": "string",
              "value": "string"
            }
          ],
          "bundle_definition": [
            {
              "product_id": 0,
              "quantity": 0,
              "variant_id": 0,
              "variant_name": "string",
              "variant_sku": "string"
            }
          ],
          "channel_metadata": [
            {
              "channel_id": 0,
              "channel_name": "string",
              "currency": "string",
              "id": 0,
              "is_inventory_sync_enabled": true,
              "legacy_product_id": 0,
              "platform": "string",
              "platform_identifier": "string",
              "platform_inventory_item_id": "string",
              "price": 0.1,
              "seller_sku": "string"
            }
          ],
          "created_on": "2019-08-24T14:15:22+00:00",
          "customs": {
            "country_code_of_origin": "string",
            "currency": "string",
            "description": "string",
            "hs_tariff_code": "string",
            "is321_eligible": true,
            "value": 0
          },
          "dimension": {
            "height": 0.1,
            "is_locked": true,
            "length": 0.1,
            "source": "string",
            "unit": "string",
            "width": 0.1
          },
          "fulfillment_settings": {
            "dangerous_goods": true,
            "is_bpm_parcel": true,
            "is_case_pick": true,
            "msds_url": "string",
            "requires_prop65": true,
            "serial_scan": {
              "exact_character_length": 0,
              "is_enabled": true,
              "prefix": "string",
              "suffix": "string"
            }
          },
          "gtin": "string",
          "id": 0,
          "inventory": {
            "inventory_id": 0,
            "on_hand_qty": 0
          },
          "is_digital": true,
          "is_image_uploaded": true,
          "lot_information": {
            "is_lot": true,
            "minimum_shelf_life_days": 0
          },
          "merge_children": [
            {
              "channel_ids": [
                0
              ],
              "completed_at": "2019-08-24T14:15:22+00:00",
              "inventory_id": 0,
              "variant_id": 0,
              "variant_name": "string"
            }
          ],
          "name": "string",
          "packaging_material_type": {
            "id": 0,
            "name": "string"
          },
          "packaging_requirement": {
            "id": 0,
            "name": "string"
          },
          "return_preferences": {
            "backup_action": {
              "id": 0,
              "name": "string"
            },
            "instructions": "string",
            "primary_action": {
              "id": 0,
              "name": "string"
            },
            "return_to_sender_backup_action": {
              "id": 0,
              "name": "string"
            },
            "return_to_sender_primary_action": {
              "id": 0,
              "name": "string"
            }
          },
          "reviews_pending": [
            "string"
          ],
          "sku": "string",
          "status": "string",
          "upc": "string",
          "updated_on": "2019-08-24T14:15:22+00:00",
          "weight": {
            "unit": "string",
            "weight": 0.1
          }
        }
      ]
    }
  ],
  "last": "string",
  "next": "string",
  "prev": "string"
}
```

**SDK Code**

```python default
import requests

url = "https://api.shipbob.com/Experimental/product"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript default
const url = 'https://api.shipbob.com/Experimental/product';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go default
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.shipbob.com/Experimental/product"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby default
require 'uri'
require 'net/http'

url = URI("https://api.shipbob.com/Experimental/product")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java default
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.shipbob.com/Experimental/product")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php default
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.shipbob.com/Experimental/product', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp default
using RestSharp;

var client = new RestClient("https://api.shipbob.com/Experimental/product");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift default
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.shipbob.com/Experimental/product")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```